#--------------------------------------------------------------------------
#  GLHPQ[WNX
#    G̃`bv̐^HPQ[W\܂
#    GL̃NXɑgݍŎg܂
#--------------------------------------------------------------------------
class Sprite_EnemyGauge < Sprite
  #--------------------------------------------------------------------------
  #  
  #--------------------------------------------------------------------------
  def initialize(viewport, character, mhp)
    super(viewport)
    @max_hp = mhp.to_f
    @timer  = Game_Timer.new()
    @character  = character
    self.bitmap = Cache.empty_bitmap()
    self.update_position()
    self.z = @character.screen_z
    self.viewport.z = @character.screen_z
  end
  
  #--------------------------------------------------------------------------
  #  NA
  #--------------------------------------------------------------------------
  def clear
    @flag = false
    self.bitmap.clear()
  end
  
  #--------------------------------------------------------------------------
  #  XV
  #--------------------------------------------------------------------------
  def update()
    super()
    @timer.update()
    self.update_position()
    self.clear() if @flag && !@timer.working?
  end
  
  #--------------------------------------------------------------------------
  #  n
  #--------------------------------------------------------------------------
  def dispose
    self.bitmap.dispose()
    super()
  end
  
  #--------------------------------------------------------------------------
  #  ʒu̍XV
  #--------------------------------------------------------------------------
  def update_position
    self.x = @character.screen_x - ($game_map.width / 2)
    self.y = @character.screen_y - $game_map.height - 18
  end
  
  #--------------------------------------------------------------------------
  #  `揈
  #--------------------------------------------------------------------------
  def Draw(width)
    @timer.start(5 * Graphics.frame_rate)
    @flag = true
    
    x = 0; y = 0; height = 2;
    color = System::Color.Lime
    color = Color.new(color.r, color.g, color.b, color.a)
    self.bitmap.clear()
    self.BackGauge(x, y, width, height)
    self.ForeGauge(x, y, width, height, color)
  end
  
  #--------------------------------------------------------------------------
  #  Q[W̌̍
  #--------------------------------------------------------------------------
  def BackGauge(x, y, width, height)
    width = $game_map.width
    bitmap.fill_rect(x, y, width, height, Color.new(0, 0, 0))
  end
  
  #--------------------------------------------------------------------------
  #  Q[W̑O
  #--------------------------------------------------------------------------
  def ForeGauge(x, y, width, height, color)
    width = (width / @max_hp) * $game_map.width
    bitmap.fill_rect(x, y, width, height, color)
  end
end