module Val
  # ԃJEg
  TIMECOUNT = 4
  
  # JEg
  DAYCOUNT = 5
  
  # 󕠓x
  HUNGER = 6
end

module SW
  # I[N̏oXCb`
  OAKFLAG = 4
  
  # tO(falsȅꍇ͒)
  NIGHT = 5
  
  FIRE = 28

end

module SurSys
  # 󕠓x̕ϐԍ
  HUNGER_V_N = 8
  
  # 󕠓xXCb`
  SV_SW = 6
  
  # I[N̏om
  OAKRATE = 10
  
  # IuWFNg̕
  EARLY   = 1
  USUALLY = 2
  SLOWLY  = 3
  
  # JEgZbg^C~O
  # EARLY, USUALLY, SLOWLY̍ŏ{ĉ
  RESETTIMING = 0
  
  # 󕠓x̍ő|Cg
  SATIETY = 10
  
  # 󕠓x
  HUNGERCOUNT = 1 #60
  
  # 󕠓xɉ񕜂HP
  RECOVERYHP = 15
  
  # 󕠓xɌHP
  REDUCTIONHP = -10
  
  # FύX 
  SCREEN_DAY_COMMON = 2
  
  # FύX 
  SCREEN_NIGHT_COMMON = 1
end


#--------------------------------------------------------------------------
#  ToCoVXe
#--------------------------------------------------------------------------
class SurvivalSystem
  #--------------------------------------------------------------------------
  #  
  #--------------------------------------------------------------------------
  def initialize
    @steps = $game_party.steps
    @gametimer         = 0   # Q[^C}[
    @hp_recovery_speed = 120 # HP̉񕜕px
    @hp_recovery_amount= 10  # HP̉񕜗
  end
  
  #--------------------------------------------------------------------------
  #  XV
  #--------------------------------------------------------------------------
  def update
    self.TimeCountUpdate()
    self.HungerUpdate()
    self.SatietyUpdate()
  end
  
  #--------------------------------------------------------------------------
  #  Ԃ̌oߏ
  #    Ԍo߂RsƖɕωiv؁j
  #    ēxAO񎞊Ԍo߂sƒɂȂ
  #--------------------------------------------------------------------------
  def TimeCountUpdate
    if $game_variables[Val::TIMECOUNT] >= 10
      $game_switches[SW::NIGHT] = true 
      $game_variables[Val::TIMECOUNT] = 0
      $game_switches[SW::FIRE] = false
      
      # IuWFNg̕
      #self.DaysElapsed()
      
      # FύX
      self.ToneChange()
    end
  end
  
  #--------------------------------------------------------------------------
  #  󕠓x̍XV
  #    󕠓x́AT1|Cg̗͂񕜂܂iv؁j
  #    󕠂œ|ƓACeXgċ_ɖ߂܂(skCxg͖)
  #--------------------------------------------------------------------------
  def HungerUpdate
    @gametimer +=1
    #------------------------------
    # 󕠓xMAX̏ꍇ 
    # -----------------------------
    if $game_variables[Val::HUNGER] >= SurSys::SATIETY
      if @gametimer % @hp_recovery_speed==0
        #$game_actors[System::CLASS_NUMBER].hp < 400
        $game_actors[System::CLASS_NUMBER].hp+=@hp_recovery_amount
        p("HP")
      end
    end  
    
    return if $game_player.stopping?
#     print("update ")
    $game_variables[8] = 0
    walk = ($game_party.steps - @steps)
    
    self.HungerReduction() if walk >= SurSys::HUNGERCOUNT
  end
  
  #--------------------------------------------------------------------------
  #  x̍XV
  #--------------------------------------------------------------------------
  def SatietyUpdate
     satiety = ($game_variables[Val::HUNGER] - SurSys::SATIETY)
     $game_variables[Val::HUNGER] = SurSys::SATIETY if satiety > 0
   end
   
   def TimeUpdate
      $game_variables[Val::TIMECOUNT] + 1
    end
  
  #--------------------------------------------------------------------------
  #  IuWFNg̕
  #--------------------------------------------------------------------------
  def DaysElapsed
    # i߂
    $game_variables[Val::DAYCOUNT] += 1
    
    # ΉZtXCb`؂
    count = $game_variables[Val::DAYCOUNT]
    $game_customenemies.ReleaseSelfSwitch("B") if count % SurSys::EARLY   == 0
    $game_customenemies.ReleaseSelfSwitch("C") if count % SurSys::USUALLY == 0
    $game_customenemies.ReleaseSelfSwitch("D") if count % SurSys::SLOWLY  == 0
  end
  
  #--------------------------------------------------------------------------
  #  󕠓x
  #--------------------------------------------------------------------------
  def HungerReduction
    p("debug")
    @steps = $game_party.steps
    if $game_switches[SurSys::SV_SW]
       $game_variables[Val::TIMECOUNT] += 1
       
      # 󕠓x[̏ꍇ
      if $game_variables[Val::HUNGER] <= 0
        $game_actors[System::CLASS_NUMBER].change_hp(SurSys::REDUCTIONHP, true)
      # 󕠓xPȏ̏ꍇ
      else
        $game_variables[Val::HUNGER] -= 1
        $game_actors[System::CLASS_NUMBER].change_hp(SurSys::RECOVERYHP, false)
      end
    end
  end
  
  #--------------------------------------------------------------------------
  #  FύX
  #--------------------------------------------------------------------------
  def ToneChange
    if $game_switches[SW::NIGHT]
      $game_temp.reserve_common_event(SurSys::SCREEN_NIGHT_COMMON)
    else
      $game_temp.reserve_common_event(SurSys::SCREEN_DAY_COMMON)
    end
  end
  
  #--------------------------------------------------------------------------
  #  I[No
  #--------------------------------------------------------------------------
  def OakAdventJudge
    if rand() < (SurSys::OAKRATE / 100)
      $game_switches[SW::OAKFLAG] = true
    else
      $game_switches[SW::OAKFLAG] = false
    end
  end
end

#--------------------------------------------------------------------------
#  lVXe̍XV
#--------------------------------------------------------------------------
class Scene_Map
  alias survivalsystem_init initialize
  def initialize
    survivalsystem_init
    @survivalsystem = SurvivalSystem.new
  end
  
  alias survivalsystem_update update
  def update
    @survivalsystem.update
    survivalsystem_update
  end
  
  #--------------------------------------------------------------------------
  #  ꏊړȌ
  #--------------------------------------------------------------------------
  alias survivalsystem_pre_transfer pre_transfer
  def pre_transfer
    # I[N̏o
    @survivalsystem.OakAdventJudge()
    survivalsystem_pre_transfer()
  end
end